/*
 * No Agenda Show for Samsung SMARTHub 2011-2013
 * 
 * (c)	Copyright 2013 Brian Cadge / selectiveblur software
 * 		feedback@selectiveblur.co.uk
 */

var Data =
{
    currentShow : 0,
    episodeName : [ ],
    episodeTitle : [ ],
    episodeURL : [ ],
    episodeDescription : [ ],
    episodePubDate : [ ],
    episodeArtwork : [ ],
    episodeDuration : [ ],
    creditmatch : ["executive producer","associate executive producer","club members:","club member:","knighthood","art ","titles:"],
    currentEpisode : 0,
    nowNextItems : null,
    TVmodelyear : '2013',
    allowResume : false,
    forceResume : '*',
    serverResume : false,
    aboutURL : 'images/bgAbout.png',
    userPlayList : [],
    vpCurrentPosition : '',
    vpState : 0,
    vpErrored : false,
    vpErrorMsg : '',
    vpStartAt : 0,
    vpStarted : false,
    vpSkipSpeed : 0,
    vpAfterSkip : false,
    vpAllowed : false,
    localConfigPath : ''
};

Data.setCurrentShow = function(index)
{
	this.currentShow = index;
};

Data.getCurrentShow = function(index)
{
	return this.currentShow;
};

Data.setEpisodeNames = function(list)
{
	this.episodeName = list;
};

Data.setEpisodeTitles = function(list)
{
	this.episodeTitle = list;
};

Data.setEpisodeURLs = function(list)
{
	this.episodeURL = list;
};

Data.setEpisodePubDate = function(list)
{
	this.episodePubDate = list;
};

Data.setEpisodeDescriptions = function(list)
{
	this.episodeDescription = list;
};

Data.setEpisodeArtwork = function(list)
{
    this.episodeArtwork = list;
};

Data.setEpisodeDurations = function(list)
{
	this.episodeDuration = list;
};

Data.getArtworkURL = function(index)
{
    var url = this.episodeArtwork[index];
    
    if (url)    // Check for undefined entry (outside of valid array)
    {
        return url;
    }
    else
    {
        return null;
    }
};


Data.getEpisodeURL = function(index)
{
    var url = this.episodeURL[index];
    
    if (url)    // Check for undefined entry (outside of valid array)
    {
        return url;
    }
    else
    {
        return null;
    }
};

Data.getEpisodeNames = function()
{
    return this.episodeName;
};

Data.getEpisodeTitle = function(index)
{
	var title = this.episodeTitle[index];
	
	if (title)
		{
			return title;
		}
	else
		{
			return "No Title";
		}
};

Data.getEpisodeName = function(index)
{
	var title = this.episodeName[index];
	
	if (title)
		{
			return title;
		}
	else
		{
			return "No Title";
		}
};


Data.getEpisodeDescription = function(index)
{
    var description = this.episodeDescription[index];
    
    if (description)    // Check for undefined entry (outside of valid array)
    {
        return description;
    }
    else
    {
        return "No description";
    }
};

Data.getEpisodePubDate = function(index)
{
    var pubdate = this.episodePubDate[index];
    
    if (pubdate)    // Check for undefined entry (outside of valid array)
    {
        return pubdate;
    }
    else
    {
        return "No Date";
    }
};


Data.getEpisodeDuration = function(index)
{
    var duration = this.episodeDuration[index];
    
    if (duration)    // Check for undefined entry (outside of valid array)
    {
        return duration;
    }
    else
    {
        return "Unknown";
    }
};


Data.getEpisodeCount = function()
{
    return this.episodeURL.length;
};

Data.clearEpisodes = function()
{
    this.episodeName.length = 0;
    this.episodeTitle.length = 0;
    this.episodeURL.length = 0;
    this.episodeDescription.length = 0;
    this.episodePubDate.length = 0;
    this.episodeArtwork.length = 0;
    this.episodeDuration.length = 0;
    this.currentEpisode = 0;
};

Data.hashCode = function(str)
{
    var hash = 0;
    if (str.length == 0) return '00000000';
    for (var i = 0; i < str.length; i++) {
        char = str.charCodeAt(i);
        hash = ((hash<<5)-hash)+char;
        hash = hash & hash; // Convert to 32bit integer
    }
    if (hash<0) hash=-hash;
    var hex = Number(hash).toString(16);
    while (hex.length < 8) {
        hex = "0" + hex;
    }
    if (hex.length>8) hex=hex.substring(0,8);
    return hex;
};

Data.hmsToSecondsOnly = function(str) {
    var p = str.split(':'),
        s = 0, m = 1;

    while (p.length > 0) {
        s += m * parseInt(p.pop());
        m *= 60;
    }

    return s;
};

Data.getCurrentDateTime = function()
{
	// Try to use the java current date
	var timecheck = new Date();
	if (timecheck.getFullYear() > 2012)
		{
		return timecheck;
		}
	else
		{
		// Java clock is not set so try to use TV clock instead.
		try
			{
			//var TVPlugin1 = document.getElementById('pluginObjectTime');
			var TVPlugin1 = sf.core.plugin('TIME');
			var currTime = TVPlugin1.GetEpochTime();
			var tvtimenow = new Date(currTime*1000);
			return tvtimenow;
			}
		catch(e)
			{
			// Just return the Java date anyway
			return timecheck;
			}
		}	
};


Data.isDTVMenuActive = function()
{
	// This function checks if the DTV Menu overlay is active so we know whether to respond to colour keys or not (Defect: DF-130314-65769)
	try
	{
		// Get the TaskManager plug
		var TaskManagerPlugin = sf.core.plugin('TASKMANAGER');
		if (TaskManagerPlugin.GetActiveApplication() == PL_TASKMANAGER_DTV_APP_MENU)
			{
			return true;
			}
		else
			{
			return false;
			}	
	}
	catch(e)
	{
		return false;
	}
};

Data.extractEpisodeNumber = function(strCode)
{
	var epNumber = '';
	
	if (strCode.substr(0,3) == 'NA-')
		{
		epNumber = strCode.substr(3);
		if (epNumber.indexOf('-'))
			{
			epNumber = epNumber.substr(0,epNumber.indexOf('-'));
			}
		else
			{
			epNumber = '';
			}
		}
	return epNumber;
};


Data.getShowText = function(strRSStext)
{
/*
 * Look for lines that begin with any of these:
 * Executive Producers:
 * Associate Executive Producers:
 * xxx Club Members:
 * Knighthoods:
 * Titles:
 * Art By:
 */
	var strShowText = "";
	var txtLines = strRSStext.split('\n');
		
	if (txtLines.length>2)
		{
		for (var index=0;index<txtLines.length;index++)
			{
			alert(index + ": "+txtLines[index]);
			
			for (var mIndex=0;mIndex<this.creditmatch.length;mIndex++)
				{
				if (txtLines[index].toLowerCase().substr(0,this.creditmatch[mIndex].length) == this.creditmatch[mIndex])
					{
					strShowText = strShowText + txtLines[index] + "<br><br>";
					}
				else
					{
					// Check for special case of club members
					if (this.creditmatch[mIndex].substr(0,4) == "club")
						{
						if (txtLines[index].toLowerCase().indexOf(this.creditmatch[mIndex]) > 3)
							{
							strShowText = strShowText + txtLines[index] + "<br><br>";
							}
						}
					}
				}
			}
		}
	else
		{
		strShowText = "Please visit www.noagendashow.com for episode credits of this show."; 
		}
	return strShowText;
};