/*
 * No Agenda Show for Samsung SMARTHub 2011-2013
 * 
 * (c)	Copyright 2013 Brian Cadge / selectiveblur software
 * 		feedback@selectiveblur.co.uk
 */

var Server =
{
    XHRObj : null,
    XHRObj2 : null,
    XHRObj3 : null,
    persistentConfig : "",
    myWidgetID : "NoAgendaShow_SamsungSH",
    //configurl : "http://static.twit.tv/selectiveblur/config.xml",
    configurl : "http://www.google.com/calendar/feeds/brettell.co.uk_jgo8cs57kmf8olr3qua4ct1le0%40group.calendar.google.com/public/full?orderby=starttime&sortorder=ascending&max-results=50&singleevents=true&fields=entry(gd:when,title,content)&start-min=2013-07-01T00:00:00-00:00&start-max=2013-07-02T00:00:00-00:00",
    showsurl : "http://feed.nashownotes.com/rss.xml",
    liveurl : "http://stream1.fralnet.com:8000/",
    liveart : "images/nagr256.png",
    liveartbig : "images/nagr384.png",
    livestreamname : "No Agenda Global Radio Live Stream",
    livetext : 'Listen to the live stream of No Agenda Global Radio.<br><span style="font-style: italic; color: #ffffff;">All Talk, No Commercials, No Agenda!</span><br><span style="color: #2CB6C7; font-size: 14pt;">The No Agenda Show is broadcast live on Thursdays & Sundays. A number of other live shows are now also carried on the network in addition to recorded podcasts, music and clips (see schedule for details).</span>',
	calurl : "http://www.google.com/calendar/feeds/q31cdncglckug84rcv3nc259os@group.calendar.google.com/public/full?orderby=starttime&sortorder=ascending&max-results=50&singleevents=true&fields=entry(gd:when,title)"	
};

Server.init = function()
{
    var success = true;

    if (this.XHRObj)
    {
        this.XHRObj.destroy();  // Save memory
        this.XHRObj = null;
    }
    
    if (this.XHRObj2)
    {
        this.XHRObj2.destroy();  // Save memory
        this.XHRObj2 = null;
    }

    if (this.XHRObj3)
    {
        this.XHRObj3.destroy();  // Save memory
        this.XHRObj3 = null;
    }

    alert(">>>>> Server Init Done");
    return success;
};

Server.fetchBootConfig = function()
{
	var success = true;
	var failure = false;
	var xmlElement = null;
	var configCalItems = null;
	var parser = null;
	var xmlDoc = null;
	
    if (this.XHRObj == null)
    {
        this.XHRObj = new XMLHttpRequest();
    }
    
    if (this.XHRObj)
    {
        alert(">>>>>>> using url "+this.configurl);
        try {
        	// Get the RSS feed with blocking until ready so no need for callback function...
        	this.XHRObj.open("GET", this.configurl, false);
        	this.XHRObj.send(null);
        }
        catch(e){
        	alert(">>>>>> XHRObj Error "+e.message);
        	return failure;
        }

        if (this.XHRObj.status != 200)
        {
        	alert(">>>>>>>> XML Server Error " + this.XHRObj.status);
        	return failure;
        }
        else
        {
        	try
        	{
                xmlElement = this.XHRObj.responseXML.documentElement;        		
        	}
        	catch(e)
        	{
        		xmlElement = null;
        	}
            
            if (!xmlElement)
            {
                alert("Failed to get valid XML");
                return failure;
            }
            else
            {
            	try
            	{
	                // Parse RSS
   	                // Get all "entry" elements
	                configCalItems = xmlElement.getElementsByTagName("entry");
	                if (configCalItems.length == 1)
	                	{
	                	// Get the config xml
	                	var configfilexmlElement = configCalItems[0].getElementsByTagName("content")[0];
	                	configfilexml = configfilexmlElement.firstChild.data;
//	        alert("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
//	      	alert(unescape(configfilexml));
	                	parser=new DOMParser();
	                	xmlDoc=parser.parseFromString(unescape(configfilexml),"text/xml");

		                // Get the "samsung" element
		                var items = xmlDoc.getElementsByTagName("samsung");
		
		                var configShows = null;
		                var configLive = null;
		                var configLiveArt = null;
		                var configLiveArtBig = null;
		                var configLivetext = null;
		                var configAboutURL = null;
		                var configCalURL = null;
		                var configLivestreamname = null;
		                var configCredits = null;
		                
		                if (items.length==1)
		                	{
		                	// Read the feed URLs
		                	var feeds = items[0].getElementsByTagName("feeds");
		                	configShows = feeds[0].attributes.getNamedItem("shows").value;
		                	configLive = feeds[0].attributes.getNamedItem("live").value;
		                	configLiveArt = feeds[0].attributes.getNamedItem("liveart").value;
		                	configLiveArtBig = feeds[0].attributes.getNamedItem("liveartbig").value;
		                	configLivestreamname = feeds[0].attributes.getNamedItem("livestreamname").value;
		                	configCredits = feeds[0].attributes.getNamedItem("credits").value;
		                	// Read the Calendar Feed config
		                	var calendarElement = items[0].getElementsByTagName("calendar")[0];
		                	if (calendarElement)
		                		{
		                		configCalURL = calendarElement.firstChild.data;
		                		}
		                	// Read the live text formatted string
		                	var livetextElement = items[0].getElementsByTagName("livetext")[0];
		                	if (livetextElement)
		                		{
		                		configLivetext = livetextElement.firstChild.data;
		                		}
		                	// Read the About URLs if present
		                	var pflags = items[0].getElementsByTagName("pages");
		                	if (pflags.length)
		                		{
		                		configAboutURL = pflags[0].attributes.getNamedItem("about").value;
		                		}
		                	}
		                
		                if (configShows && configLive && configLiveArt && configLiveArtBig && configLivestreamname)
		                	{
		                	this.showsurl = configShows;
		                	this.liveurl = configLive;
		                	this.liveart = configLiveArt;
		                	this.liveartbig = configLiveArtBig;
		                	this.livestreamname = configLivestreamname;
		                	}
		                
		                if (configLivetext)
		                	{
		                	this.livetext = configLivetext;
		                	}

		                if (configCalURL)
		                	{
		                	this.calurl = configCalURL;
		                	}

		                if (configAboutURL)
		                	{
		                	Data.aboutURL = configAboutURL;
		                	}
		                
		                if (configCredits)
		                	{
		                	Data.creditmatch = configCredits.split("|");
		                	}
		                	
		                return success;
	                	}
	                else
	                	{
	                	// Should only be a single entry in the calendar for the config date.
	                	return failure;
	                	}
            	}
            	catch(e)
            	{
            		alert("Failed to read valid XML from config file "+e.message);
            		return failure;
            	}
             }
        }       
    }
    else
    {
        alert("Failed to create XHR");
        return failure;
    }
};


Server.objectExists = function(theurl)
{
	var success = true;
	var failure = false;
	
	if (!this.checkConnection())
		{
		return failure;
		}
	
    if (this.XHRObj3 == null)
    {
        this.XHRObj3 = new XMLHttpRequest();
    }

    if (this.XHRObj3)
    {
        try {
        	// Get the object with blocking until ready so no need for callback function...
        	this.XHRObj3.open("GET", theurl, false);
        	this.XHRObj3.send(null);
        }
        catch(e){
        	alert(">>>>>> XHRObj3 Error "+e.message);
            this.XHRObj3.destroy();  // Save memory
            this.XHRObj3 = null;       	
        	return failure;
        }     
        if (this.XHRObj3.status != 200)
        	{
            this.XHRObj3.destroy();  // Save memory
            this.XHRObj3 = null;       	
        	return failure;
        	}
        else
        	{
            this.XHRObj3.destroy();  // Save memory
            this.XHRObj3 = null;       	        	
        	return success;
        	}
    }
};


Server.fetchEpisodeList = function(rssurl)
{
	var success = true;
	var failure = false;
	var xmlElement = null;
	
    if (this.XHRObj2 == null)
    {
        this.XHRObj2 = new XMLHttpRequest();
    }
    
    // Clear the Episodes cache...
    Data.clearEpisodes();
    
    if (this.XHRObj2)
    {
        alert(">>>>>>> using url "+rssurl);
        try {
        	// Get the RSS feed with blocking until ready so no need for callback function...
        	this.XHRObj2.open("GET", rssurl, false);
        	this.XHRObj2.send(null);
        }
        catch(e){
        	alert(">>>>>> XHRObj2 Error "+e.message);
        	return failure;
        }     
        if (this.XHRObj2.status == 200)
        {
        	// Got HTTP Response 200 so something returned...
        	try
        	{
                xmlElement = this.XHRObj2.responseXML.documentElement;        		
        	}
        	catch(e)
        	{
        		xmlElement = null;
        	}
        	
            if (!xmlElement)
            {
                alert("******* Failed to get valid XML ********");
                return failure;
            }
            else
            {
            	try
            	{
	                // Parse RSS
	                // Get all "item" elements
	                var items = xmlElement.getElementsByTagName("item");
	                
	                var showNames = [ ];
	                var showTitles = [ ];
	                var showURLs = [ ];
	                var showPubDates = [ ];
	                var showDescriptions = [ ];
	                var showDurations = [ ];
	                var showArtworks = [ ];
	                var dateStr;
	                var showDescription = '';
	                var mp3URL = '';
	                var imgURL = '';
	                
	                alert("********** "+items.length + " items loaded from RSS **********");
	                
	                // Insert the Live stream as Show #0
	                var index = 0;
           			showNames[index] = "NAR-LIVE-STREAM1";
                    showTitles[index] = this.livestreamname;
                    showURLs[index] = this.liveurl;
                    showPubDates[index] = "Live";
                    showDescriptions[index] = this.livetext;
                    showDurations[index] = "00:00:00";
                    showArtworks[index] = this.liveart;
	                
	                for (index = 0; index < items.length; index++)
	                {
	                    var nameElement = items[index].getElementsByTagName("title")[0];
	                    var descriptionElement = items[index].getElementsByTagName("itunes:summary")[0];
	                    var titleElement = items[index].getElementsByTagName("itunes:subtitle")[0];
	                    var episodelengthElement = items[index].getElementsByTagName("itunes:duration")[0];
	                    var linkElement = items[index].getElementsByTagName("link")[0];
	                    var pubdateElement = items[index].getElementsByTagName("pubDate")[0];
	                    var htmldescriptionElement = items[index].getElementsByTagName("description")[0];
	                    
	                    // Get the MP3 URL, which is inside an enclosure tag...
	                    var encElement = items[index].getElementsByTagName("enclosure");
	                	mp3URL = encElement[0].attributes.getNamedItem("url").value;
	                    
	                	// Get the full description text so we can extract the image url from it...
	                    var htmlsrc = htmldescriptionElement.firstChild.data;
	                    // Remove all the line breaks and replace with a space
	                    htmlsrc = htmlsrc.replace(/(\r\n|\n|\r)/gm," ");
	                    // Get rid of any double spaces
	                    htmlsrc = htmlsrc.replace(/\s+/g," ");
	                    imgURL = this.extractImageURL(htmlsrc);
	                    if (imgURL == '')
	                    	{
	                    	imgURL = 'images/nasdefault.jpg';
	                    	}
	                    
	                    if (titleElement && descriptionElement && mp3URL && pubdateElement)
	                    {
	                    	// dateStr = dateFormat(Date.parse(pubdateElement.firstChild.data),'D, d M yy');
                    		dateStr = dateFormat(pubdateElement.firstChild.data,'ddd, d mmm yyyy');
                   			showDescription = descriptionElement.firstChild.data;

                   			showNames[index+1] = nameElement.firstChild.data;
	                        showTitles[index+1] = titleElement.firstChild.data;
	                        showURLs[index+1] = mp3URL;
	                        showPubDates[index+1] = dateStr;
	                        showDescriptions[index+1] = showDescription;
	                        showDurations[index+1] = episodelengthElement.firstChild.data;
	                        showArtworks[index+1] = imgURL;
	                    }
	                }
	            
	                Data.setEpisodeNames(showNames);
	                Data.setEpisodeTitles(showTitles);
	                Data.setEpisodeURLs(showURLs);
	                Data.setEpisodePubDate(showPubDates);
	                Data.setEpisodeDescriptions(showDescriptions);
	                Data.setEpisodeDurations(showDurations);
	                Data.setEpisodeArtwork(showArtworks);
	                return success;
            	}
            	catch(e)
            	{
            		alert("Failed to retrieve valid XML "+e.message);
            		return failure;
            	}
            }
        }
        else
        {
        	alert("*********** "+this.XHRObj2.status+" http code returned ********");
        	return failure;
        }
    }
    else
    {
        alert("************** Failed to create XHR2 Object ************");
        return failure;
    }
};


Server.fetchNowNextInfo = function()
{
	var success = true;
	var failure = false;
	var xmlElement = null;
	var timenow = Data.getCurrentDateTime();
	var timestart = (timenow.getTime()-86400000);  // Go back 24hrs
	var timeend = (timenow.getTime()+(86400000*4));  // Go forward 4 days
		
	var timespan = '&start-min='+dateFormat(timestart,"yyyy-mm-dd")+'T00:00:00-00:00&start-max='+dateFormat(timeend,"yyyy-mm-dd")+'T23:59:59-00:00';
	
alert(">>>>>>>> timespan="+timespan);
alert(">>>>>>>> calurl= "+this.calurl+timespan);

    if (this.XHRObj == null)
    {
        this.XHRObj = new XMLHttpRequest();
    }
    
    if (this.XHRObj)
    {
        try {
        	// Get the RSS feed with blocking until ready so no need for callback function...
        	this.XHRObj.open("GET", this.calurl+timespan, false);
        	this.XHRObj.send(null);
        }
        catch(e){
        	alert(">>>>>> XHRObj Error "+e.message);
        	return failure;
        }

        if (this.XHRObj.status != 200)
        {
        	alert(">>>>>>>> Calendar XML Server Error " + this.XHRObj.status);
        	return failure;
        }
        else
        {
        	try
        	{
                xmlElement = this.XHRObj.responseXML.documentElement;        		
        	}
        	catch(e)
        	{
        		xmlElement = null;
        	}
            
            if (!xmlElement)
            {
                alert("Failed to get valid calendar XML");
                return failure;
            }
            else
            {
            	try
            	{
	                // Get all "entry" elements
	                Data.nowNextItems = xmlElement.getElementsByTagName("entry");
	                return success;
            	}
            	catch(e)
            	{
            		alert("Failed to retrieve valid XML "+e.message);
            		return failure;
            	}
            }
        }       
    }
    else
    {
        alert("Failed to create calendar XHR");
        return failure;
    }
};


Server.refreshNowNext = function()
{
	var timenow = Data.getCurrentDateTime();

    // Go through the calendar items returned to find what's on now and next...

	onNow.showtitle = null;
	onNext.showtitle = null;
	
	if (Data.nowNextItems != null)
		{
	    for (var index = 0; index < Data.nowNextItems.length; index++)
	    {
	    	try
	    	{
		        var titleElement = Data.nowNextItems[index].getElementsByTagName("title")[0];
		        var startend = Data.nowNextItems[index].getElementsByTagName("gd:when")[0];
		        var startTime = this.parseGoogleDate(startend.attributes.getNamedItem("startTime").value);
		        var endTime = this.parseGoogleDate(startend.attributes.getNamedItem("endTime").value);
		        	        
		        if ((startTime <= timenow) && (endTime > timenow))
		        	{
		        	onNow.showtitle = titleElement.firstChild.data;
		        	onNow.showstart = startTime;
		        	onNow.showend = endTime;
		        	};
		        
		        if (startTime > timenow)
		        	{
		        	onNext.showtitle = titleElement.firstChild.data;
		        	onNext.showstart = startTime;
		        	onNext.showend = endTime;
		        	break;
		        	};
	    	}
	    	catch(e)
	    	{
	    		alert("Google calendar feed contains invalid XML "+e.message);
	    		break;
	    	}
	    }
	
	    if ((onNow.showtitle == null) && (Data.nowNextItems.length))
	    	{
	    	onNow.showtitle = 'TWiT Live Re-runs / Live Chat';
	    	onNow.showstart = null;
	    	};	    		    
		}
};


Server.parseGoogleDate = function(d)
{
	var googleDate = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2})\.(\d{3})([+-]\d{2}):(\d{2})$/;
	
    var m = googleDate.exec(d);
    var year   = +m[1];
    var month  = +m[2];
    var day    = +m[3];
    var hour   = +m[4];
    var minute = +m[5];
    var second = +m[6];
    var msec   = +m[7];
    var tzHour = +m[8];
    var tzMin  = +m[9];
    var tzOffset = new Date().getTimezoneOffset() + tzHour * 60 + tzMin;

    return new Date(year, month - 1, day, hour, minute - tzOffset, second, msec);
};


Server.checkConnection = function() {
	var success = true;
	var failure = false;	
	
	//var networkPlugin  = document.getElementById('pluginObjectNetwork');
	var networkPlugin = sf.core.plugin('NETWORK');
    // Get active connection type - wired or wireless.
    var currentInterface = networkPlugin.GetActiveType();

    // If no active connection.
    if (currentInterface === -1) {
            return failure;
    }

    // Check physical connection of current interface.
    var physicalConnection = networkPlugin.CheckPhysicalConnection(currentInterface);

    // If not connected or error.
    if (physicalConnection != 1) {
            return failure;
    }

    return success;
};



Server.extractImageURL = function(srccode)
{
	var failure = '';
	// find the first img src tag..
	var lPos = srccode.indexOf('img src=');
	if (lPos==-1) return failure;
	var theurl = srccode.substring(lPos+9); //get the url after the quote
alert("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ looking for closing quote");
	var ePos = theurl.indexOf('"');
	if (ePos==-1) return failure;
	theurl = theurl.substring(0,ePos);
alert("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ URL is "+theurl);
	return theurl;	
};