/*
 * No Agenda Show for Samsung SMARTHub 2011-2013
 * 
 * (c)	Copyright 2013 Brian Cadge / selectiveblur software
 * 		feedback@selectiveblur.co.uk
 */

alert('SceneShowPlay.js loaded');

var playList = [{
	url: 'http',
	title: 'title'
}];

//sf.service.VideoPlayer.STATE_PLAYING = 1;
//sf.service.VideoPlayer.STATE_STOPPED  = 2;
//sf.service.VideoPlayer.STATE_PAUSED   = 3;
//sf.service.VideoPlayer.STATE_BUFFERING    = 4;
//sf.service.VideoPlayer.STATE_SCANNING = 5;

var skipSpeeds=new Array(-480,-120,-30,30,120,480);
var skipSteps=new Array('Skip <<<','Skip <<','Skip <','Skip >','Skip >>','Skip >>>');
var hStates = '';

function SceneShowPlay() {

};

SceneShowPlay.prototype.initialize = function () {
	alert("SceneShowPlay.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	$('#bgShowPlay').sfImage({src:'images/bgNoAgenda.png'});
	$('#imgEpisodeArt').sfImage({src:'images/showBuffer.png'});
	$('#hbShowPlay').sfKeyHelp({'return':'Back'});
	
	// blank the debug text
	$('#lbDebug').sfLabel({text:''});
	
	try
	{
		sf.service.VideoPlayer.init({
			onend:function(){
				vpReset();
				if (!Server.checkConnection())
					{
					// Network was disconnected
					Data.vpErrored = true;
					handlePlayerError('The network is disconnected. Please check your connection and try again.');
					}
				else
					{
					// Return to episode selection screen DF-130726-88130
					vpReset();
					sf.service.VideoPlayer.hide();
			    	sf.scene.hide('ShowPlay');
			    	sf.scene.show('ShowSelect');
			    	sf.scene.focus('ShowSelect');
					}
			},
			onerror:function(error) {
				Data.vpErrored = true;
				vpReset();
				if (!Server.checkConnection())
					{
					// Network was disconnected
					handlePlayerError('The network is disconnected. Please check your connection and try again.');
					}
				else
					{
					handlePlayerError('Sorry, there was a problem playing the show. Please check your connection and try again.<br><br>Technical Data: '+error);					
					}
		    },
			onstatechange:function(state) {
		        Data.vpState = state;
		        //hStates=hStates+state;
		        //$('#lbDebug').sfLabel({text:hStates});
		        if ((state==sf.service.VideoPlayer.STATE_PLAYING) && (!Data.vpStarted))
		        	{
		        	Data.vpStarted=true;
		        	// Cancel Skip - fixes QA issue if FF/RW pressed continuously during buffering
		        	sf.service.VideoPlayer.Skip.cancel();
		        	}
		        setHelpBar(state);
		        //alert("&&&&&&&&&&&&&&&&& STATE CHANGE "+state);
		        //Data.vpCurrentPosition = document.getElementById("sf-service-videoplayer-full-infobar-time-0").innerHTML;
		        //alert("&&&&&&&&&&&|"+Data.vpCurrentPosition+"|");
			}		    
		});
		
		// Return key
	//	sf.service.VideoPlayer.setKeyHandler(sf.key.RETURN, 
	//	function(){
	//		vpReset();
	//	});
		
		sf.service.VideoPlayer.setKeyHandler(sf.key.ENTER, 
		function(){
			// Prevent default pause/play action per Samsung requirements
			sf.key.preventDefault();
		});

		sf.service.VideoPlayer.setKeyHandler(27, 
		function(){
			// Prevent TV (Mute) key default action per Samsung requirements (no mute on BR with TV key)
			// System still handles Mute function
			sf.key.preventDefault();
		});

		sf.service.VideoPlayer.setKeyHandler(77, 
		function(){
			// Prevent TV key default action per Samsung requirements (no mute on BR with TV key) - this is probably not needed.
			sf.key.preventDefault();
		});

		sf.service.VideoPlayer.setKeyHandler(222, 
		function(){
			// Prevent SOURCE key action per Samsung requirements (this is not really needed here)
			sf.key.preventDefault();
		});

		sf.service.VideoPlayer.setKeyHandler(1219, 
		function(){
			// Prevent 3D key action (otherwise it displays 'Not Supported' on some devices)
			sf.key.preventDefault();
		});
		
		sf.service.VideoPlayer.setKeyHandler(sf.key.EXIT, 
		function(){
			sf.key.preventDefault();
			vpReset();
			sf.service.VideoPlayer.hide();
			sf.core.exit(true); // Have to exit to be compliant with UX guidelines
		});
		sf.service.VideoPlayer.setKeyHandler(sf.key.TOOLS, 
		function(){
			// Prevent use of the tools key
			sf.key.preventDefault();
		});
		
		// Hide the progress bar until playback starts (DF-130726-88122)
		document.getElementById("sf-service-videoplayer-mini-infobar-progress-bg").style.visibility = 'hidden';
		document.getElementById("sf-service-videoplayer-mini-infobar-progress-play").style.visibility = 'hidden';
		
	}
	catch(e)
	{
		alert("VideoPlayer Init failed "+e);
	};

	
	var vLeft = parseInt($("#vpPlayer").css('left'));
	var vTop = parseInt($("#vpPlayer").css('top'));
	var vHeight = parseInt($("#vpPlayer").css('height'));
	var vWidth = parseInt($("#vpPlayer").css('width'));
	sf.service.VideoPlayer.setPosition({
		left:vLeft,
		top:vTop,
		width:vWidth,
		height:vHeight,
	});
	
	// sf.service.VideoPlayer.show();
};

SceneShowPlay.prototype.handleShow = function (data) {
	alert("SceneShowPlay.handleShow()");
	// this function will be called when the scene manager show this scene
	
	if (Data.currentEpisode)
		{
		var txtShowID = "Episode ID: &nbsp;" + Data.getEpisodeName(Data.currentEpisode) + ", &nbsp;&nbsp;&nbsp;Published: &nbsp;" + Data.getEpisodePubDate(Data.currentEpisode);	
		}
	else
		{
		var txtShowID = "All Talk, No Commercials, No Agenda ...";
		}
	
	$('#lbTitle').sfLabel({text:Data.getEpisodeTitle(Data.currentEpisode)});
	$('#lbShowID').sfLabel({text:txtShowID});
	if (Data.currentEpisode)
		{
		$('#lbShowDescription').sfLabel({text:Data.getShowText(Data.getEpisodeDescription(Data.currentEpisode))});
		}
	else
		{
		refreshGuideList();
		}
	Data.vpState=sf.service.VideoPlayer.STATE_STOPPED;
	
	setTimeout(vpStartPlayback,100);
	alert("++++++++++++++++++++++++++++++++++++++++ "+Data.getEpisodeURL(Data.currentEpisode));
	alert("++++++++++++++++++++++++++++++++++++++++ "+Data.getEpisodeTitle(Data.currentEpisode));
	
	//$('#lbDebug').sfLabel({text:'|'+Data.getEpisodeURL(Data.currentEpisode)+'|'});
};

SceneShowPlay.prototype.handleHide = function () {
	alert("SceneShowPlay.handleHide()");
	// this function will be called when the scene manager hide this scene
	$('#imgEpisodeArt').sfImage({src:'images/showBuffer.png'});
	Data.vpAllowed = false;
	vpReset();
};

SceneShowPlay.prototype.handleFocus = function () {
	alert("SceneShowPlay.handleFocus()");
	// this function will be called when the scene manager focus this scene
};

SceneShowPlay.prototype.handleBlur = function () {
	alert("SceneShowPlay.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
};

SceneShowPlay.prototype.handleKeyDown = function (keyCode) {
	alert("SceneShowPlay.handleKeyDown(" + keyCode + ")");
	switch (keyCode) {
		case sf.key.LEFT:
			break;
		case sf.key.RIGHT:
			break;
		case sf.key.UP:
			break;
		case sf.key.DOWN:
			break;
		case sf.key.ENTER:
			break;
		case sf.key.STOP:
			if (Data.vpState == 0)
				{
				$('#hbShowPlay').sfKeyHelp('showNotice', {text: 'Stopping stream...please wait', timeout: 0});
				}
			vpReset();
			break;
		case sf.key.PAUSE:
			if ((Data.vpState == sf.service.VideoPlayer.STATE_PLAYING) && (Data.currentEpisode) && (!Data.vpAfterSkip))  //Don't allow pause when repositioning DF-130726-88143
				{
				sf.service.VideoPlayer.pause();
				}
			break;
		case sf.key.PLAY:
			if (!Server.checkConnection())
				{
				// Network was disconnected
				handlePlayerError('The network is disconnected. Please check your connection and try again.');
				}
			else
				{
				switch (Data.vpState) {
					case sf.service.VideoPlayer.STATE_STOPPED:
						var item = playList[0];
						item.fullscreen = false;
						setHelpBar(sf.service.VideoPlayer.STATE_BUFFERING);
						sf.service.VideoPlayer.play(item);
						break;
					case sf.service.VideoPlayer.STATE_PAUSED:
						if (sf.service.VideoPlayer.Skip.isInProgress())
							{
							setHelpBar(0);
							Data.vpAfterSkip = true;
							sf.service.VideoPlayer.Skip.stop();  //Resume playing
							}
						else
							{
							sf.service.VideoPlayer.resume();
							}
						break;
					case sf.service.VideoPlayer.STATE_SCANNING: //Skipping
						if (sf.service.VideoPlayer.Skip.isInProgress())
							{
							setHelpBar(0);
							Data.vpAfterSkip = true;
							sf.service.VideoPlayer.Skip.stop();  //Resume playing
							}
						break;
					}
				}
			break;
		case sf.key.FF:
			if (((Data.vpState == sf.service.VideoPlayer.STATE_PLAYING) || (Data.vpState == sf.service.VideoPlayer.STATE_PAUSED)) && (Data.currentEpisode) && (!Data.vpAfterSkip))
				{
				if (sf.service.VideoPlayer.Skip.isInProgress())
					{
					if (Data.vpSkipSpeed < 5)
						{
						Data.vpSkipSpeed++;
						}
					}
				else
					{
						Data.vpSkipSpeed = 3;
					}
				sf.service.VideoPlayer.Skip.start(skipSpeeds[Data.vpSkipSpeed]);
				$('#hbShowPlay').sfKeyHelp('showNotice', {text:skipSteps[Data.vpSkipSpeed], timeout: 0});
				}
			break;
		case sf.key.REW:
			if (((Data.vpState == sf.service.VideoPlayer.STATE_PLAYING) || (Data.vpState == sf.service.VideoPlayer.STATE_PAUSED)) && (Data.currentEpisode) && (!Data.vpAfterSkip))
				{
				if (sf.service.VideoPlayer.Skip.isInProgress())
					{
					if (Data.vpSkipSpeed > 0)
						{
						Data.vpSkipSpeed--;
						}
					}
				else
					{
						Data.vpSkipSpeed = 2;
					}
				sf.service.VideoPlayer.Skip.start(skipSpeeds[Data.vpSkipSpeed]);
				$('#hbShowPlay').sfKeyHelp('showNotice', {text:skipSteps[Data.vpSkipSpeed], timeout: 0});
				}
			break;
		case sf.key.RETURN:
			sf.key.preventDefault();
			vpReset();
			sf.service.VideoPlayer.hide();
	    	sf.scene.hide('ShowPlay');
	    	sf.scene.show('ShowSelect');
	    	sf.scene.focus('ShowSelect');
	    	break;
		case sf.key.EXIT:
			sf.key.preventDefault();
			vpReset();
			sf.service.VideoPlayer.hide();
			sf.core.exit(true); // Have to exit to be compliant with UX guidelines
			break;
		default:
			alert("handle default key event, key code(" + keyCode + ")");
			break;
	}
};

function vpStartPlayback()
{
	if (Data.vpAllowed == false) return;
	
	setHelpBar(sf.service.VideoPlayer.STATE_BUFFERING); //Buffering
	playList[0].url = Data.getEpisodeURL(Data.currentEpisode);
	playList[0].title = Data.getEpisodeTitle(Data.currentEpisode);
	var item = playList[0];
	item.fullscreen = false;
	sf.service.VideoPlayer.show();
	document.getElementById("_plugin_Player_0").style.visibility = 'hidden';
	try
	{
		if (Data.currentEpisode)
			{
			// Show the total time count for the recorded shows.
			document.getElementById("sf-service-videoplayer-mini-infobar-time-1").style.visibility = 'visible';
			document.getElementById("sf-service-videoplayer-mini-infobar-time-2").style.visibility = 'visible';
			// Hide the progress bar until playback starts (DF-130726-88122)
			document.getElementById("sf-service-videoplayer-mini-infobar-progress-bg").style.visibility = 'hidden';
			document.getElementById("sf-service-videoplayer-mini-infobar-progress-play").style.visibility = 'hidden';
			//sf.service.VideoPlayer.setKeyHandler(sf.key.FF, null);  //videoplayer service handles skipping for recorded shows
			//sf.service.VideoPlayer.setKeyHandler(sf.key.REW, null); 
			}
		else
			{
			// Hide the total time count for live stream.
			document.getElementById("sf-service-videoplayer-mini-infobar-time-1").style.visibility = 'hidden';
			document.getElementById("sf-service-videoplayer-mini-infobar-time-2").style.visibility = 'hidden';	
			document.getElementById("sf-service-videoplayer-mini-infobar-progress-bg").style.visibility = 'hidden';
			document.getElementById("sf-service-videoplayer-mini-infobar-progress-play").style.visibility = 'hidden';
			}
		// Force the default error message text to English (local language not allowed)
		document.getElementById("sf-service-videoplayer-mini-neterr-text").innerHTML="Service is unavailable due to network or service interference.";
		document.getElementById("sf-service-videoplayer-mini-notsup-text").innerHTML="You can't see the picture. We do not support the format.";
		document.getElementById("sf-service-videoplayer-mini-neterr-text").style.visibility = 'hidden';
		document.getElementById("sf-service-videoplayer-mini-neterr-icon").style.visibility = 'hidden';
		document.getElementById("sf-service-videoplayer-mini-notsup-text").style.visibility = 'hidden';
		document.getElementById("sf-service-videoplayer-mini-notsup-icon").style.visibility = 'hidden';
	}
	catch(e)
	{
		// Just fail to hide the total time gracefully.
	}

	if (!Server.checkConnection())
		{
			// Network was disconnected
			$('#imgEpisodeArt').sfImage({src:'images/nasdefault.jpg'});
			handlePlayerError('The network is disconnected. Please check your connection and try again.');
		}
	else
		{
		sf.service.VideoPlayer.play(item);
		document.getElementById("_plugin_Player_0").style.visibility = 'hidden';
		var smallArtURL = Data.getArtworkURL(Data.currentEpisode);
		var theArtURL = smallArtURL;
		if (Data.currentEpisode)
			{
			if (smallArtURL.indexOf("-SM.jpg") > 0)
				{
				var BigArtURL = smallArtURL.replace("-SM.jpg","-BIG.jpg");
				if (Server.objectExists(BigArtURL))
					{
					theArtURL = BigArtURL;
					}
				else
					{
					BigArtURL = smallArtURL.replace("-SM.jpg",".jpg");
					if (Server.objectExists(BigArtURL))
						{
						theArtURL = BigArtURL;
						}
					else
						{
						theArtURL = "images/nasdefault.jpg";	
						}
					}
				}		
			}
		else
			{
			theArtURL = Server.liveartbig;
			}
		alert("+++++++++++++++++++++++++++++++++++++++++++++++++++"+theArtURL);
		$('#imgEpisodeArt').sfImage({src:theArtURL});		
		}
};


function setHelpBar(pState)
{
	switch (pState) {
		case 0: //Repositioning
			$('#hbShowPlay').sfKeyHelp({'STOP':'Stop','RETURN':'Back'});
			$('#hbShowPlay').sfKeyHelp('showNotice', {text: 'Repositioning...please wait', timeout: 0});
			break;
		case sf.service.VideoPlayer.STATE_PLAYING:
			if (!Data.vpAfterSkip)
				{
				if (Data.currentEpisode)
					{
					$('#hbShowPlay').sfKeyHelp({'STOP':'Stop','REW':'Skip Back','PAUSE':'Pause','FF':'Skip Forward','RETURN':'Back'});
					}
				else
					{
					$('#hbShowPlay').sfKeyHelp({'STOP':'Stop','RETURN':'Back'});
					}
				$('#hbShowPlay').sfKeyHelp('hideNotice');
				if (Data.currentEpisode)
					{
					// Show the progress bar for recorded shows only once playback started (DF-130726-88122)
					document.getElementById("sf-service-videoplayer-mini-infobar-progress-bg").style.visibility = 'visible';
					document.getElementById("sf-service-videoplayer-mini-infobar-progress-play").style.visibility = 'visible';
					}
				}
			break;
		case sf.service.VideoPlayer.STATE_STOPPED:
			if (Data.currentEpisode)
				{
				$('#hbShowPlay').sfKeyHelp({'PLAY':'Play Show','RETURN':'Back'});
				}
			else
				{
				$('#hbShowPlay').sfKeyHelp({'PLAY':'Play Live Stream','RETURN':'Back'});
				}
			// Hide the progress bar
			document.getElementById("sf-service-videoplayer-mini-infobar-progress-bg").style.visibility = 'hidden';
			document.getElementById("sf-service-videoplayer-mini-infobar-progress-play").style.visibility = 'hidden';
			break;
		case sf.service.VideoPlayer.STATE_PAUSED:
			$('#hbShowPlay').sfKeyHelp({'STOP':'Stop','REW':'Skip Back','PLAY':'Resume Playing','FF':'Skip Forward','RETURN':'Back'});
			break;
		case sf.service.VideoPlayer.STATE_BUFFERING:
			if (Data.vpAfterSkip) Data.vpAfterSkip=false;
			$('#hbShowPlay').sfKeyHelp({'STOP':'Stop','RETURN':'Back'});
			$('#hbShowPlay').sfKeyHelp('showNotice', {text: 'Connecting...', timeout: 0});
			break;
		case sf.service.VideoPlayer.STATE_SCANNING: //Scanning
			$('#hbShowPlay').sfKeyHelp({'STOP':'Stop','REW':'Skip Back','PLAY':'Resume Playing','FF':'Skip Forward','RETURN':'Back'});
			break;
	};
//	if (pState>1)
//		{
//		$('#hbShowPlay').sfKeyHelp('showNotice', {text: 'State: '+pState, timeout: 5000});	
//		}
	
};

function vpReset()
{
	if (sf.service.VideoPlayer.Skip.isInProgress())
		{
		sf.service.VideoPlayer.Skip.cancel();
		}
	sf.service.VideoPlayer.stop();
	Data.vpStarted=false;
	Data.vpAfterSkip=false;
	setHelpBar(sf.service.VideoPlayer.STATE_STOPPED);
	$('#hbShowPlay').sfKeyHelp('hideNotice');
	hStates='';
	try
	{
		// Hide the progress bar
		document.getElementById("sf-service-videoplayer-mini-infobar-progress-bg").style.visibility = 'hidden';
		document.getElementById("sf-service-videoplayer-mini-infobar-progress-play").style.visibility = 'hidden';
	}
	catch(e)
	{
		
	}
};

function handlePlayerError(error) {
	vpReset();
	$("#hbShowPlay").sfKeyHelp('showNotice', {text: 'A network error occurred.', timeout: 13000});
	Data.vpErrorMsg = error;
	Data.vpErrored=false;
	setTimeout(showthepopup,700);
};

function showthepopup()
{
	//sf.service.VideoPlayer.hide();
	sf.scene.focus('ShowPlay');
	$('#PopUpQuit').sfPopup({
		text: Data.vpErrorMsg,
		buttons:['OK'],
		timeout: 45000,
		defaultfocus:0,
		callback:function(rlt){
			// Try to ensure the scene has focus
			sf.scene.focus('ShowPlay');
			}
	});
	$('#PopUpQuit').sfPopup('show');
};

function refreshGuideList()
{
	var timenow = Data.getCurrentDateTime();

	var sGuideList = '';
	var dCurrentDay = new Date('2000-01-01');
	var nGuideLines = 0;
	
    // Go through the calendar items returned to find what's on from now...
	if (Data.nowNextItems != null)
		{
	    for (var index = 0; index < Data.nowNextItems.length; index++)
		    {
		        var titleElement = Data.nowNextItems[index].getElementsByTagName("title")[0];
		        var startend = Data.nowNextItems[index].getElementsByTagName("gd:when")[0];
		        var startTime = Server.parseGoogleDate(startend.attributes.getNamedItem("startTime").value);
		        var endTime = Server.parseGoogleDate(startend.attributes.getNamedItem("endTime").value);
		        
		        if (endTime > timenow)
		        	{
			        if (startTime.toDateString() != dCurrentDay.toDateString())
			        	{
			        	// Start a new day line in the guide
			        	dCurrentDay = startTime;
			        	sGuideList = sGuideList + '<span style="display: inline-block; width: 701px; background: #2E9EA8; border-bottom: 2px solid #28888E; padding-top:4px; color: #ffffff;">&nbsp;&nbsp;'+dateFormat(dCurrentDay,"dddd, mmmm d, yyyy")+"</span><br>";
			        	nGuideLines++;
			        	}
		        	// Include this item in the guide list...
			        sGuideList = sGuideList + '<span style="display: inline-block; width : 701px; border-bottom: 2px solid #28888E; padding-top:4px;"><span style="color: #ffffff; padding-top: 4px;">&nbsp;&nbsp;'+dateFormat(startTime,"HH:MM")+" - "+dateFormat(endTime,"HH:MM")+"&nbsp;</span>";
		        	sGuideList = sGuideList + '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span style="color: #e4b936;">'+titleElement.firstChild.data + "</span>";
		        	if (startTime <= timenow)
		        		{
		        		// The show is live now
		        		sGuideList = sGuideList + '&nbsp;&nbsp;&nbsp;<span style="background: #ff0000; color: #ffffff;">&nbsp;&nbsp;LIVE NOW&nbsp;&nbsp;</span></span><br>';
		        		}
		        	else
		        		{
		        		sGuideList = sGuideList + '</span><br>';
		        		}
		        	nGuideLines++;
		        	if (nGuideLines>=13) break;
		        	};
		    }
		$('#lbShowDescription').sfLabel({text:sGuideList});
		}
	else
		{
		$('#lbShowDescription').sfLabel({text:'<span style="display: inline-block; width : 701px; background: #2E9EA8; border-bottom: 2px solid #28888E; padding-top:4px; color: #ffffff;">&nbsp;&nbsp;No Guide Listings Available</span>'});
		}
};