/*
 * No Agenda Show for Samsung SMARTHub 2011-2013
 * 
 * (c)	Copyright 2013 Brian Cadge / selectiveblur software
 * 		feedback@selectiveblur.co.uk
 */

alert('SceneShowSelect.js loaded');

var showSelect = 
{
		bAllowWrap : 0
};

function SceneShowSelect() {

};

SceneShowSelect.prototype.initialize = function () {
	alert("SceneShowSelect.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	$('#imgBackShowSelect').sfImage({src:'images/bgOnDemand.png'});
	$('#hbShowSelect').sfKeyHelp({'leftright':'Select Show','enter':'Play Show','blue':'About','return':'Exit App'});  //Return key label updated DF-130726-88119
	$("#hbShowSelect").sfKeyHelp('showNotice', {text: Data.getEpisodeCount()+' shows available.', timeout: 20000});
	
	this.bAllowWrap=false;
	
	if (Data.getEpisodeCount()>1)
		{
		Data.currentEpisode = 1;
		this.setListDisplay(1);
		}
	else
		{
		Data.currentEpisode = 0;
		this.setListDisplay(0);
		}
	
	$('#imgFadeLeft').sfImage({src:'images/carousel-left-fade.png'});
	$('#imgFadeRight').sfImage({src:'images/carousel-right-fade.png'});
};

SceneShowSelect.prototype.handleShow = function (data) {
	alert("SceneShowSelect.handleShow()");
	// this function will be called when the scene manager show this scene
};

SceneShowSelect.prototype.handleHide = function () {
	alert("SceneShowSelect.handleHide()");
	// this function will be called when the scene manager hide this scene
};

SceneShowSelect.prototype.handleFocus = function () {
	alert("SceneShowSelect.handleFocus()");
	// this function will be called when the scene manager focus this scene
};

SceneShowSelect.prototype.handleBlur = function () {
	alert("SceneShowSelect.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
};

SceneShowSelect.prototype.handleKeyDown = function (keyCode) {
	alert("SceneShowSelect.handleKeyDown(" + keyCode + ")");
	var showIndex = Data.currentEpisode;
	switch (keyCode) {
		case sf.key.LEFT:
			if (showIndex>0) {
				--showIndex;
				this.setListDisplay(showIndex);
			}
			break;
		case sf.key.RIGHT:
			if (showIndex<Data.getEpisodeCount()-1) {
				showIndex++;
				// Update the slider images...
				this.setListDisplay(showIndex);
			}
			break;
		case sf.key.UP:
			break;
		case sf.key.DOWN:
			break;
		case sf.key.RED:
			//dumpJS();
			break;
		case sf.key.BLUE:
			if (!Data.isDTVMenuActive())
				{
		    	sf.scene.hide('ShowSelect');
		    	sf.scene.show('about');
		    	sf.scene.focus('about');				
				}
			break;
		case sf.key.ENTER:
			if (!Server.checkConnection())
				{
				// Network was disconnected
				networkError('The network is disconnected. Please check your connection and try again.');
				}
			else
				{
				// Switch to the ShowPlay scene and play show/stream
				Data.vpAllowed = true;
		    	sf.scene.hide('ShowSelect');
		    	sf.scene.show('ShowPlay');
		    	sf.scene.focus('ShowPlay');
				}
			break;
		case sf.key.RETURN:
			// Do nothing, allow default
			break;
		case sf.key.EXIT:
			// Do nothing, allow default
			break;
		default:
			alert("handle default key event, key code(" + keyCode + ")");
			break;
	}
	Data.currentEpisode = showIndex;
};

SceneShowSelect.prototype.setListDisplay = function(showIndex)
{

	// sets the simulated scrolling boxes to the current position
	var rPos;
	var nShowCount = Data.getEpisodeCount();

	if (showIndex > 0)
		{
		$('#imgShow0').sfImage({'src':Data.getArtworkURL(showIndex-1)});
		$('#imgShow0').sfImage('show');
		$('#imgFadeLeft').sfImage('show');
		}
	else
		{
		$('#imgShow0').sfImage('hide');
		$('#imgFadeLeft').sfImage('hide');
		}
	
	$('#imgShow1').sfImage({'src':Data.getArtworkURL(showIndex)});
	
	for (var index = 1; index<4; index++)
		{
		rPos = 1+index;
		// Refresh the right side....
		if (showIndex+index < nShowCount)
			{
			$('#imgShow'+rPos).sfImage({'src':Data.getArtworkURL(showIndex+index)});
			$('#imgShow'+rPos).sfImage('show');
			if (index==3) $('#imgFadeRight').sfImage('show');
			}
		else
			{
			$('#imgShow'+rPos).sfImage('hide');
			if (index==3) $('#imgFadeRight').sfImage('hide');
			}
		}
	$('#labShowTitle').sfLabel({'text':Data.getEpisodeTitle(showIndex)});
	if (showIndex)
		{
		var showHeader = "No Agenda Show Podcast Recording<br>";
		var showEpNumber = Data.extractEpisodeNumber(Data.getEpisodeName(showIndex));
		if (showEpNumber != '')	showHeader = showHeader + "Episode Number: "+showEpNumber+", &nbsp;";
		showHeader = showHeader + "Published: "+Data.getEpisodePubDate(showIndex) + "<br>Duration: "+Data.getEpisodeDuration(showIndex);
		}
	else
		{
		//var showHeader = 'Listen to the Live Stream of No Agenda Global Radio.<br><span style="font-style: italic; color: #ffffff;">All Talk, No Commercials, No Agenda!</span><br><span style="color: #2CB6C7; font-size: 14pt;">The No Agenda Show is broadcast live on Thursdays & Sundays. A number of other live shows are now also carried on the network in addition to recorded podcasts, music and clips (see schedule for details).</span>';
		var showHeader = Server.livetext;
		}
	$('#labShowName').sfLabel({'text':Data.getEpisodeTitle(showIndex)});
	$('#labShowHeader').sfLabel({'text':showHeader});
	
	Data.getShowText(Data.getEpisodeDescription(showIndex));

};

function networkError(textError)
{
	alert("********* "+textError);
	$('#PopUpNet').sfPopup({
		'text': textError,
		buttons:['OK'],
		timeout: 45000,
		callback:function(rlt){
			// Nothing to do
		}
	});
	$('#PopUpNet').sfPopup('show');
};


function dumpJS()
{
	var xhttp=new XMLHttpRequest();
	xhttp.open("GET","$MANAGER_WIDGET/Common/API/Plugin.js",false);
	xhttp.send("");
	xmlDoc=xhttp.responseText;
	alert(xmlDoc);
};