/*
 * No Agenda Show for Samsung SMARTHub 2011-2013
 * 
 * (c)	Copyright 2013 Brian Cadge / selectiveblur software
 * 		feedback@selectiveblur.co.uk
 */

alert('Scenedebug.js loaded');

function Scenedebug() {

};

Scenedebug.prototype.initialize = function () {
	alert("Scenedebug.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	$('#imgDebug').sfImage({
		src:'images/bgDebug.png'
	});
	$('#hbDebug').sfKeyHelp({
		'return':'Back'
	});
	$('#lbDebug').sfLabel({
		text:'label'
	});
};

Scenedebug.prototype.handleShow = function (data) {
	alert("Scenedebug.handleShow()");
	// this function will be called when the scene manager show this scene
	refreshDebug();
};

Scenedebug.prototype.handleHide = function () {
	alert("Scenedebug.handleHide()");
	// this function will be called when the scene manager hide this scene
};

Scenedebug.prototype.handleFocus = function () {
	alert("Scenedebug.handleFocus()");
	// this function will be called when the scene manager focus this scene
};

Scenedebug.prototype.handleBlur = function () {
	alert("Scenedebug.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
};

Scenedebug.prototype.handleKeyDown = function (keyCode) {
	alert("Scenedebug.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
		case sf.key.LEFT:
			break;
		case sf.key.RIGHT:
			break;
		case sf.key.UP:
			break;
		case sf.key.DOWN:
			break;
		case sf.key.ENTER:
			break;
		case sf.key.RETURN:
			sf.key.preventDefault();
	    	sf.scene.hide('debug');
	    	sf.scene.show('about');
	    	sf.scene.focus('about');
	    	break;			
		default:
			alert("handle default key event, key code(" + keyCode + ")");
			break;
	}
};


function refreshDebug()
{
	$('#lbDebug').sfLabel({text:'Please Wait...'});
	
	var debuginfo = '<span style="color: #ffffff; font-size: 24pt;">System Information</span><br><br>';
	
	//var TVPlugin = document.getElementById('pluginObjectTv');
	var TVPlugin = sf.core.plugin('TV');
	if (TVPlugin!=null)
		{
		var productCode = TVPlugin.GetProductCode(1);
		debuginfo+='Product ID: &nbsp;'+productCode+'<br>';
		}
	debuginfo+='Firmware: &nbsp;'+ sf.env.getFirmwareVer().version + '<br>';
	debuginfo+='Resolution: &nbsp;'+ sf.env.getResolution()+'<br>';
	debuginfo+='Product Type: &nbsp;';
	var productType = sf.env.getProductType()+'';
	switch (productType){
		case '0':
			debuginfo+='Television';
			break;
		case '1':
			debuginfo+='Monitor (with TV)';
			break;
		case '2':
			debuginfo+='Blu-ray / HTS / PVR';
			break;
		default:
			debuginfo+='('+productType+')';
			break;
	}
	debuginfo+='<br>';	
	var browserVersion=navigator.userAgent;
	debuginfo+='User agent: &nbsp;<span style="font-size: 14pt;">'+browserVersion+'</span><br>';
	var timenow = new Date();
	debuginfo+='Local time: &nbsp;'+dateFormat(timenow,"ddd mmm dd yyyy HH:MM:ss o")+'<br>';
	try
	{
		//var TVPlugin1 = document.getElementById('pluginObjectTime');
		var TVPlugin1 = sf.core.plugin('TIME');
		var currTime = TVPlugin1.GetEpochTime();
		var tvtimenow = new Date(currTime*1000);
		debuginfo+='Local TV time: &nbsp;'+dateFormat(tvtimenow,"ddd mmm dd yyyy HH:MM:ss o")+'<br>';
	}
	catch(e)
	{
		// Do Nothing
	}
	
	try
	{
		//var networkPlugin  = document.getElementById('pluginObjectNetwork');
		var networkPlugin = sf.core.plugin('NETWORK');
	    // Get active connection type - wired or wireless.
	    var currentInterface = networkPlugin.GetActiveType();

	    switch(currentInterface){
	    	case 0:
	    		debuginfo+='Network Type: Wireless<br>';
	    		break;
	    	case 1:
	    		debuginfo+='Network Type: Wired<br>';
	    		break;
	    	case -1:
	    		debuginfo+='Network Type: No Network Connection<br>';
	    		break;
	    	default:
	    		debuginfo+='Network Type: Unknown ('+currentInterface+')<br>';
	    		break;
	    }
	    // Check physical connection of current interface.
	    var physicalConnection = networkPlugin.CheckPhysicalConnection(currentInterface);
	    if (physicalConnection!=1)
	    	{
	    	debuginfo+='Network state: Disconnected<br>';
	    	}
	    else
	    	{
	    	debuginfo+='Network state: Connected<br>';
	    	}
	}
	catch(e)
	{
		// Do nothing
	}
	
	debuginfo+='Widget ID: &nbsp;'+Server.myWidgetID+' version '+sf.env.getAppVersion()+'<br>';
	debuginfo+='Config File: '+Server.persistentConfig+'<br>';
	debuginfo+='<br>Server published: &nbsp;'+Data.getEpisodeCount()+' shows<br>';

	if (Data.nowNextItems != null)
		{
		debuginfo+='Calendar items: &nbsp;'+Data.nowNextItems.length+' events<br>';
		}
	else
		{
		debuginfo+='No calendar items available.<br>';
		}
	
	$('#lbDebug').sfLabel({'text':debuginfo});
};